.486
.model  flat, stdcall  
option  casemap :none 

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

;########################################################
WindPos       STRUCT
  x        dd ?
  y        dd ?
  xc       dd ?
  yc       dd ?
WindPos       ENDS

WindPosStruct STRUCT
  nwp WindPos <>  ;normal window position
  fsp WindPos <>  ;full-screen window position
WindPosStruct ENDS
;########################################################

WinMain           PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc           PROTO :DWORD, :DWORD, :DWORD, :DWORD

;########################################################
SetFsp            PROTO :HWND
;########################################################

PictureW      equ 600
PictureH      equ 400

.data 

;########################################################
;HWND_TOPMOST   EQU -1
;HWND_NOTOPMOST EQU -2
FsState         dd HWND_NOTOPMOST   ;full-screen state
;########################################################

ClassName       db "Win32asm_class",0
DisplayName     db ".:. Blank Window .:.",0

MyRect      RECT <0,0,PictureW,PictureH>

black           dd 0000000h

;########################################################
YesNo           dd 0
szStartText  db 'Would You Like to Start in Full-Screen Mode ?',0
szStartTitle db 'Blank Screen Startup',0
;########################################################

.data? 
hInstance       dd ?
hmainDC         dd ?                                        
hmainbmp        dd ? 

;########################################################
hWin            dd ?
;########################################################
ScnWidth        dd ?
ScnHeight       dd ?
wps  WindPosStruct <>
;########################################################

.code 

start:

        INVOKE  MessageBox,NULL,offset szStartText,offset szStartTitle,MB_YESNO
        cmp     eax,IDYES
        jnz     NotFsMode

        mov     YesNo,eax

NotFsMode:

    xor     edi,edi
    invoke  GetModuleHandle,edi
    mov     hInstance, eax
    invoke  WinMain,hInstance,edi,edi,SW_SHOWDEFAULT
    invoke  ExitProcess,eax
WinMain   PROC hInst :DWORD,hPrevInst :DWORD,CmdLine :DWORD,CmdShow :DWORD

LOCAL   wc   :WNDCLASSEX
LOCAL   msg  :MSG
LOCAL   hwnd :HWND

        mov     wc.cbSize,sizeof WNDCLASSEX
        mov     wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.cbClsExtra,NULL


        mov     wc.cbWndExtra,NULL      
        push    hInst

        pop     wc.hInstance

        mov     wc.hbrBackground,COLOR_BTNFACE+4
        
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset ClassName             
        mov     wc.hIcon,NULL
        invoke  LoadCursor,NULL,IDC_ARROW				
        mov     wc.hCursor,eax      
        mov     wc.hIconSm,NULL
        
        invoke  RegisterClassEx, ADDR wc


        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,PictureW/2
        push    eax

        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,PictureH/2
        pop     ebx

        invoke  CreateWindowEx,WS_EX_LEFT,ADDR ClassName,ADDR DisplayName,
                WS_OVERLAPPEDWINDOW,ebx,eax,PictureW,PictureH,NULL,NULL,hInst,NULL
        mov     hwnd,eax
        push eax

        mov edi, hwnd
        invoke  ShowWindow,edi,SW_SHOWNORMAL
        invoke  UpdateWindow,edi

_Start:
        invoke  GetMessage,ADDR msg,NULL,0,0
        test    eax, eax
        jz      _Exit
        invoke  TranslateMessage,ADDR msg
        invoke  DispatchMessage,ADDR msg

        jmp     _Start
_Exit:

        mov     eax,msg.wParam
        ret

WinMain         ENDP

WndProc  PROC   uses edx ecx ebx esi edi  hWnd :HWND,uMsg :DWORD,wParam :DWORD,lParam :DWORD

	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT

mov eax, uMsg  

    .IF eax == WM_PAINT 

invoke BeginPaint,hWnd, ADDR ps
mov    hdc,eax


invoke BitBlt, hdc, 0,0, PictureW,PictureH, hmainDC, 0, 0, SRCCOPY

invoke EndPaint,hWnd, ADDR ps

; -------------------------------------------------------------------------
    .ELSEIF     eax == WM_KEYDOWN

cmp wParam, VK_ESCAPE
je destroy

;########################################################
        cmp     wParam,VK_F1
        jnz     SkipWindPos

        mov     eax,FsState
        xor     eax,HWND_TOPMOST xor HWND_NOTOPMOST
        mov     edx,offset wps
        cmp     eax,HWND_NOTOPMOST
        mov     FsState,eax
        jz      SetWindPos

        push    eax
        push    edx
        INVOKE  GetWindowRect,hWnd,edx
        pop     edx
        mov     eax,[edx].RECT.right
        mov     ecx,[edx].RECT.bottom
        sub     eax,[edx].RECT.left
        sub     ecx,[edx].RECT.top
        mov     [edx].WindPos.xc,eax
        mov     [edx].WindPos.yc,ecx
        pop     eax
        add     edx,WindPosStruct.fsp-WindPosStruct.nwp

SetWindPos:
        push    eax
        INVOKE  SetWindowPos,hWnd,eax,[edx].WindPos.x,[edx].WindPos.y,[edx].WindPos.xc,[edx].WindPos.yc,SWP_SHOWWINDOW
        pop     eax
        neg     eax
        dec     eax
        INVOKE  ShowCursor,eax                                        ;####### ShowCursor TRUE or FALSE

SkipWindPos:
;########################################################

; -------------------------------------------------------------------------
    .ELSEIF     eax == WM_TIMER

invoke FillRect, hmainDC, addr MyRect,black
invoke RedrawWindow, hWnd, addr MyRect, 0, RDW_INVALIDATE	

; -------------------------------------------------------------------------

;########################################################
;MINMAXINFO STRUCT
; ptReserved        POINT <>
; ptMaxSize         POINT <>
; ptMaxPosition     POINT <>
; ptMinTrackSize    POINT <>
; ptMaxTrackSize    POINT <>
;MINMAXINFO ENDS

    .ELSEIF     eax == WM_GETMINMAXINFO

        cmp dword ptr FsState,HWND_TOPMOST
        jnz     SkipMinMax

        mov     edx,lParam
        mov     eax,wps.fsp.xc
        mov     ecx,wps.fsp.yc
        mov     [edx].MINMAXINFO.ptMaxSize.x,eax
        mov     [edx].MINMAXINFO.ptMaxSize.y,ecx
        mov     [edx].MINMAXINFO.ptMaxTrackSize.x,eax
        mov     [edx].MINMAXINFO.ptMaxTrackSize.y,ecx
        mov     [edx].MINMAXINFO.ptMinTrackSize.x,eax
        mov     [edx].MINMAXINFO.ptMinTrackSize.y,ecx
        mov     eax,wps.fsp.x
        mov     ecx,wps.fsp.y
        mov     [edx].MINMAXINFO.ptMaxPosition.x,eax
        mov     [edx].MINMAXINFO.ptMaxPosition.y,ecx

SkipMinMax:
;########################################################

   .ELSEIF eax == WM_CREATE

;########################################################
        mov     eax,hWnd
        mov     hWin,eax
;########################################################

invoke CreateSolidBrush,black
mov black,eax


  invoke GetDC, hWnd
  mov hdc, eax

  mov esi,PictureW
  mov edi,PictureH


  invoke CreateCompatibleDC, hdc
  mov dword ptr [hmainDC],eax

  invoke CreateCompatibleBitmap, hdc, esi, edi
  mov dword ptr [hmainbmp],eax

  invoke SelectObject, [hmainDC], eax
  
  invoke ReleaseDC,hWnd, hdc

;########################################################
        INVOKE  SetFsp,hWnd
;########################################################

;########################################################
        xor     eax,eax
        cmp     eax,YesNo
        jz      DontFullScreen

        INVOKE  PostMessage,hWin,WM_KEYDOWN,VK_F1,eax

DontFullScreen:

;########################################################

; ====================================
; ====================================  

    .ELSEIF eax == WM_CLOSE

;########################################################
destroy:
invoke DeleteDC, [hmainDC]
invoke DeleteObject, [hmainbmp]
invoke DeleteObject, black
invoke PostQuitMessage,NULL
;########################################################

    .ELSE

invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
ret

.ENDIF

xor eax,eax
ret

WndProc         ENDP

;########################################################
SetFsp  PROC    hWnd:HWND

        INVOKE  GetSystemMetrics,SM_CXSCREEN
        mov     ScnWidth,eax
        INVOKE  GetSystemMetrics,SM_CYSCREEN
        mov     ScnHeight,eax
        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,hWnd,esp
        push    0
        push    0
        INVOKE  ClientToScreen,hWnd,esp
        pop     edx                       ;x
        pop     ecx                       ;y
        pop     eax                       ;wr.left
        sub     eax,edx
        mov     wps.fsp.x,eax
        pop     eax                       ;wr.top
        sub     eax,ecx
        mov     wps.fsp.y,eax
        sub     esp,sizeof RECT
        INVOKE  GetClientRect,hWnd,esp
        pop     edx                       ;cr.left
        pop     ecx                       ;cr.top
        INVOKE  ClientToScreen,hWnd,esp
        pop     edx                       ;cr.right
        pop     ecx                       ;cr.bottom
        pop     eax                       ;wr.right
        sub     eax,edx
        add     eax,ScnWidth
        sub     eax,wps.fsp.x
        mov     wps.fsp.xc,eax
        pop     eax                       ;wr.bottom
        sub     eax,ecx
        add     eax,ScnHeight
        sub     eax,wps.fsp.y
        mov     wps.fsp.yc,eax
        ret

SetFsp  ENDP
;########################################################

END start